var canvas;
var puzzle_context;

var working_div;

var puzzle = new Image();
puzzle.onload = load_picture_and_cut_into_tiles;

var b_width = 240;
var b_height = 240;

var num_blocks = 16;

var block_size;// = 5;
// Threshold is a value that a possible match must not exceed
var threshold = 100;
var threshold_lr = Number.MAX_VALUE;  // max value is like no threshold  

var rec_limit = 10;

// for puzzle image data
var puzData;

function getRed(imgData, x, y){
  return imgData.data[((y * (imgData.width * 4)) + (x*4))];
}
function getGreen(imgData, x, y, width, height){
  return imgData.data[((y * (imgData.width * 4)) + (x*4)) + 1];
} 
function getBlue(imgData, x, y, width, height){
  return imgData.data[((y * (imgData.width * 4)) + (x*4)) + 2];
}
function getAlpha(imgData, x, y, width, height){
  return imgData.data[((y * (imgData.width * 4)) + (x*4)) + 3];
}   

tiles = new Array();

// TILE OBJECT
function tile() {
  // image data
  this.data = -1;
  
  // indecies to other tiles in tiles array
  this.top = -2;
  this.left = -2;
  this.bottom = -2;
  this.right = -2;
  
  this.add_link = function(tuple, dir){
      var index = tuple[0];
      var w = tuple[1];
      
      if (dir == "top"){
        if (this.left == index){
          if (this.left_weight < w){
            this.top = -1;
          } else {
            this.left = -1;
            this.left_weight = -1;
            this.top = index;
            this.top_weight = w;
          }
        } else if (this.right == index){
          if (this.right_weight < w){
            this.top = -1;
          } else {
            this.right = -1;
            this.right_weight = -1;
            this.top = index;
            this.top_weight = w;
          }
        } else if (this.bottom == index){
          if (this.bottom_weight < w){
            this.top = -1;
          } else {
            this.bottom = -1;
            this.bottom_weight = -1;
            this.top = index;
            this.top_weight = w;
          }
        } else {
            this.top = index;
            this.top_weight = w;
        }                      
      } else if (dir == "bottom"){
        if (this.left == index){
          if (this.left_weight < w){
            this.bottom = -1;
          } else {
            this.left = -1;
            this.left_weight = -1;
            this.bottom = index;
            this.bottom_weight = w;
          }
        } else if (this.right == index){
          if (this.right_weight < w){
            this.bottom = -1;
          } else {
            this.right = -1;
            this.right_weight = -1;
            this.bottom = index;
            this.bottom_weight = w;
          }
        } else if (this.top == index){
          if (this.top_weight < w){
            this.bottom = -1;
          } else {
            this.top = -1;
            this.top_weight = -1;
            this.bottom = index;
            this.bottom_weight = w;
          }
        } else{
            this.bottom = index;
            this.bottom_weight = w;
          }
      } else if (dir == "left"){
        if (this.bottom == index){
          if (this.bottom_weight < w){
            this.left = -1;
          } else {
            this.bottom = -1;
            this.bottom_weight = -1;
            this.left = index;
            this.left_weight = w;
          }
        } else if (this.right == index){
            if (this.right_weight < w){
              this.left = -1;
            } else {
              this.right = -1;
              this.right_weight = -1;
              this.left = index;
              this.left_weight = w;
            }
        } else if (this.top == index){
            if (this.top_weight < w){
              this.left = -1;
            } else {
              this.top = -1;
              this.top_weight = -1;
              this.left = index;
              this.left_weight = w;
            }
        } else{
          this.left = index;
          this.left_weight = w;
        }          
      } else if (dir == "right"){
        if (this.bottom == index){
          if (this.bottom_weight < w){
            this.right = -1;
          } else {
            this.bottom = -1;
            this.bottom_weight = -1;
            this.right = index;
            this.right_weight = w;
          }
        } else if (this.left == index){
          if (this.left_weight < w){
            this.right = -1;
          } else {
            this.left = -1;
            this.left = -1;
            this.right = index;
            this.right_weight = w;
          }
        } else if (this.top == index){
          if (this.top_weight < w){
            this.right = -1;
          } else {
            this.top = -1;
            this.top_weight = -1;
            this.right = index;
            this.right_weight = w;
          }         
        } else{
          this.right = index;
          this.right_weight = w;
        }
      }
    } 
  
  this.top_weight = Number.MAX_VALUE;
  this.left_weight = Number.MAX_VALUE;
  this.bottom_weight = Number.MAX_VALUE;
  this.right_weight = Number.MAX_VALUE;         
  
  this.drawn = false;
}

var final_canvas;
var final_canvas_context;

var drawn_tiles; 

function load_picture_and_cut_into_tiles(){

  block_size = parseInt(document.getElementById("block_size").value);
  drawn_tiles = new Array();
  tiles = new Array();    
  canvas = document.getElementById('datadrop');
	puzzle_context = canvas.getContext('2d'); 

	canvas.width = puzzle.width;
	canvas.height = puzzle.height;
  puzzle_context.drawImage(puzzle,0,0);
  
  puzData = puzzle_context.getImageData(0,0,puzzle.width,puzzle.height);
  
  var temp;
  var temp_tile;
  var temp_context;
  
  for(var i=0; i < 4; i++){
    for(var j=0; j < 4; j++){
      temp_tile = new tile();
      temp_tile.data = puzzle_context.getImageData((i*60),(j*60),(60),(60));
      tiles.push(temp_tile);
    }
  }
  var message = "i\tbottom\ttop\tleft\tright\n";
  var message2 = "i\tbottom\ttop\tleft\tright\n";
  for(var i=0; i<tiles.length; i++){
    
    tiles[i].add_link(best_top(i), "top");
    tiles[i].add_link(best_bottom(i), "bottom");
    tiles[i].add_link(best_left(i), "left");
    tiles[i].add_link(best_right(i), "right");
    
    message += i + "\t" + tiles[i].bottom + "\t" + tiles[i].top + "\t" + tiles[i].left + "\t" + tiles[i].right + "\n";
    //message2 += i + "\t" + tiles[i].bottom_weight + "\t" + tiles[i].top_weight + "\t" + tiles[i].left_weight + "\t" + tiles[i].right_weight + "\n";
  }
  
  for(var i=0; i<tiles.length; i++){
  
    if (tiles[i].left != -1 && (i != tiles[tiles[i].left].right)){
      //alert("Tile " + i + " cant go left to " + tiles[i].left);
      tiles[i].left = -1;
    }
    if (tiles[i].right != -1 && (i != tiles[tiles[i].right].left)){
      //alert("Tile " + i + " cant go right to " + tiles[i].right);
      tiles[i].right = -1;
    }
    if (tiles[i].bottom != -1 && (i != tiles[tiles[i].bottom].top)){
      //alert("Tile " + i + " cant go down to " + tiles[i].bottom);
      tiles[i].bottom = -1;
    }    
    if (tiles[i].top != -1 && (i != tiles[tiles[i].top].bottom)){
      //alert("Tile " + i + " cant go up to" + tiles[i].top);
      tiles[i].top = -1;
    }       
    message2 += i + "\t" + tiles[i].bottom + "\t" + tiles[i].top + "\t" + tiles[i].left + "\t" + tiles[i].right + "\n";
  }
  //alert(message);
  //alert(message2);
  
  canvas.width = 500;
  canvas.height = 500;
  puzzle_context = canvas.getContext('2d');
  
  drawTree(tiles[15], 250,250,0);
  working_div.style.opacity = 0.0;
  
  working_div.transitionend = document.body.removeChild(working_div);
}

function drawTree(t, x, y, rec){
//  if (t.drawn)
//    return;
  //if ($.inArray({x:y}, drawn_tiles) != -1)
  //  return;
  if (rec < rec_limit){ 
    if (t.right != -1)
      drawTree(tiles[t.right], x+60, y,rec+1);  
    if (t.top != -1)
      drawTree(tiles[t.top], x, y-60,rec+1);     
    if (t.left != -1)
      drawTree(tiles[t.left], x-60, y,rec+1);
    if (t.bottom != -1)
      drawTree(tiles[t.bottom], x, y+60,rec+1); 
  }
  puzzle_context.putImageData(t.data,x,y);
  //drawn_tiles.push({x:y});
//  t.drawn = true;
}

// Helper function
//      returns the sum of values in an array    
function sum(x){
  var ret = 0;
  for(var i=0;i<x.length; i++)
    ret += x[i];
  return ret;
}

// Compares image data :
// left edge of imgData_1 to right edge of imgData_2
// L->R and R->L done in blocks
// B->T and T->B done by single pixles
   
function left_to_right(imgData_1, imgData_2){

  var r1 = new Array(block_size * block_size);
  var r2 = new Array(block_size * block_size);
  var g1 = new Array(block_size * block_size);
  var g2 = new Array(block_size * block_size);
  var b1 = new Array(block_size * block_size);
  var b2 = new Array(block_size * block_size);
  var a1 = new Array(block_size * block_size);
  var a2 = new Array(block_size * block_size); 
  
  var rgba1, rgba2;
  
  var diff = 0; 
  
  for(var i=0; i < imgData_1.height-1-block_size; i++){
    for(var j=0; j<block_size; j++){
      for(var k=0; k<block_size; k++){
        r1[(j*block_size)+k] = getRed(imgData_1, 0 + k, i + j);
        r2[(j*block_size)+k] = getRed(imgData_2, imgData_2.width - k, i + j);
        g1[(j*block_size)+k] = getGreen(imgData_1, 0 + k, i + j);                             
        g2[(j*block_size)+k] = getGreen(imgData_2, imgData_2.width - k, i + j);                            
        b1[(j*block_size)+k] = getBlue(imgData_1, 0 + k, i + j);       
        b2[(j*block_size)+k] = getBlue(imgData_2, imgData_2.width - k, i + j);     
        a1[(j*block_size)+k] = getAlpha(imgData_1, 0 + k, i + j);       
        a2[(j*block_size)+k] = getAlpha(imgData_2, imgData_2.width - k, i + j); 
      }
    }
    rgba1 = sum(r1) + sum(g1) + sum(b1) + sum(a1);
    rgba2 = sum(r2) + sum(g2) + sum(b2) + sum(a2);
    
    diff += Math.abs(rgba1 - rgba2);
  }
  diff = (diff/imgData_1.height-1)/block_size;
  return diff;      
}

function bottom_to_top(imgData_1, imgData_2){ 
  var r1,r2;
  var g1,g2;
  var b1,b2;
  var a1,a2; 
  
  var rgba1, rgba2;
  
  var diff = 0; 
  for(var i=0; i < imgData_1.width-1; i++){
    r1 = getRed(imgData_1, i, imgData_1.height-1);
    r2 = getRed(imgData_2, i, 0);
    g1 = getGreen(imgData_1, i, imgData_1.height-1);
    g2 = getGreen(imgData_2, i, 0);
    b1 = getBlue(imgData_1, i, imgData_1.height-1);
    b2 = getBlue(imgData_2, i, 0);        
    a1 = getAlpha(imgData_1, i, imgData_1.height-1);
    a2 = getAlpha(imgData_2, i, 0);
    
    rgba1 = r1 + g1 + b1 + a1;
    rgba2 = r2 + g2 + b2 + a2;
    
    diff += Math.abs(rgba1 - rgba2);
  }
  diff = diff/imgData_1.width-1;
  return diff;
}     

function top_to_bottom(imgData_1,imgData_2){
  
  var r1,r2;
  var g1,g2;
  var b1,b2;
  var a1,a2; 
  
  var rgba1, rgba2;
  
  var diff = 0; 
  
  for(var i=0; i < imgData_1.width-1; i++){
    r1 = getRed(imgData_1, i, 0);
    r2 = getRed(imgData_2, i, imgData_2.height-1);
    g1 = getGreen(imgData_1, i, 0);
    g2 = getGreen(imgData_2, i, imgData_2.height-1);
    b1 = getBlue(imgData_1, i, 0);
    b2 = getBlue(imgData_2, i, imgData_2.height-1);        
    a1 = getAlpha(imgData_1, i, 0);
    a2 = getAlpha(imgData_2, i, imgData_2.height-1);
    
    rgba1 = r1 + g1 + b1 + a1;
    rgba2 = r2 + g2 + b2 + a2;
    
    diff += Math.abs(rgba1 - rgba2);
  }
  diff = diff/imgData_1.width-1;
  return diff;
}    

function right_to_left(imgData_1, imgData_2){
   
  var r1 = new Array(block_size * block_size);
  var r2 = new Array(block_size * block_size);
  var g1 = new Array(block_size * block_size);
  var g2 = new Array(block_size * block_size);
  var b1 = new Array(block_size * block_size);
  var b2 = new Array(block_size * block_size);
  var a1 = new Array(block_size * block_size);
  var a2 = new Array(block_size * block_size); 
  
  var rgba1, rgba2;
  
  var diff = 0; 
  
  for(var i=0; i < imgData_1.height-1-block_size; i++){
    for(var j=0; j<block_size; j++){
      for(var k=0; k<block_size; k++){
        r1[(j*block_size)+k] = getRed(imgData_1, imgData_1.width - k, i + j);
        r2[(j*block_size)+k] = getRed(imgData_2, 0 + k, i + j);
        g1[(j*block_size)+k] = getGreen(imgData_1, imgData_1.width - k, i + j);                      
        g2[(j*block_size)+k] = getGreen(imgData_2, 0 + k, i + j);                             
        b1[(j*block_size)+k] = getBlue(imgData_1, imgData_1.width - k, i + j); 
        b2[(j*block_size)+k] = getBlue(imgData_2, 0 + k, i + j);        
        a1[(j*block_size)+k] = getAlpha(imgData_1, imgData_1.width - k, i + j); 
        a2[(j*block_size)+k] = getAlpha(imgData_2, 0 + k, i + j);        
      }
    }
    
    rgba1 = sum(r1) + sum(g1) + sum(b1) + sum(a1);
    rgba2 = sum(r2) + sum(g2) + sum(b2) + sum(a2);
    
    diff += Math.abs(rgba1 - rgba2);
  }
  diff = (diff/imgData_1.height-1)/block_size;
  return diff;
}


// best_bottom | top | left | right
// checks all tiles against edge and returns the index of the one with
// the lowest score
      
function best_bottom(i){
  var min = Number.MAX_VALUE;
  var min_index = -1;
  var curr;
  for(var j=0; j<tiles.length; j++){
    if (j==i) 
      continue;
    curr = bottom_to_top(tiles[i].data, tiles[j].data);
    if (curr < min && curr < threshold){
      min_index = j;
      min = curr;
    }
  }
  return [min_index, min];
}

function best_top(i){
  var min = Number.MAX_VALUE;
  var min_index = -1;
  var curr;
  for(var j=0; j<tiles.length; j++){
    if (j==i) 
      continue;
    curr = top_to_bottom(tiles[i].data, tiles[j].data);
    if (curr < min && curr < threshold){
      min_index = j;
      min = curr;
    }
  }
  return [min_index, min];
}

function best_left(i){
  var min = Number.MAX_VALUE;
  var min_index = -1;
  var curr;
  for(var j=0; j<tiles.length; j++){
    if (j==i) 
      continue;
    curr = left_to_right(tiles[i].data, tiles[j].data);
    if (curr < min && curr < threshold_lr){
      min_index = j;
      min = curr;
    }
  }
  return [min_index, min];
}

function best_right(i){
  var min = Number.MAX_VALUE;
  var min_index = -1;
  var curr;
  for(var j=0; j<tiles.length; j++){
    if (j==i) 
      continue;
    curr = right_to_left(tiles[i].data, tiles[j].data);
    if (curr < min && curr < threshold_lr){
      min_index = j;
      min = curr;
    }
  }
  return [min_index, min];
}            
